/// <reference types="node" />
import EventEmitter from "events";
import childProcess from "child_process";
import Discord from "discord.js";
import InstanceManager, { InstanceOptions } from "./InstanceManager";
declare class Instance extends EventEmitter {
    manager: InstanceManager;
    id: number;
    env: {
        [key: string]: string | undefined;
    };
    process?: childProcess.ChildProcess;
    instance: InstanceOptions;
    _evals: Map<string, Promise<any>>;
    _fetches: Map<string, Promise<any>>;
    constructor(manager: typeof InstanceManager.prototype, id: number, instance: InstanceOptions);
    spawn: (timeout?: number) => Promise<childProcess.ChildProcess>;
    kill: () => void;
    respawn: (timeout?: number | undefined) => Promise<childProcess.ChildProcess>;
    send: (message: unknown) => Promise<Discord.Shard>;
    fetchClientValue: (prop: string) => Promise<unknown>;
    eval: {
        (script: string): Promise<unknown>;
        <T>(fn: (client: Discord.Client<boolean>) => T): Promise<T>;
        <T_1, P>(fn: (client: Discord.Client<boolean>, context: Discord.Serialized<P>) => T_1, context: P): Promise<T_1>;
    };
    _handleMessage: (message: unknown) => void;
    _handleExit: (respawn?: boolean | undefined, timeout?: number | undefined) => void;
}
export default Instance;
